diff -b -B --ignore-all-space -N -u -r nsaserefpolicy/policy/modules/kernel/corenetwork.te.in serefpolicy-3.6.32/policy/modules/kernel/corenetwork.te.in
--- nsaserefpolicy/policy/modules/kernel/corenetwork.te.in	2009-09-16 16:01:19.000000000 +0200
+++ serefpolicy-3.6.32/policy/modules/kernel/corenetwork.te.in	2010-01-29 15:56:04.452639869 +0100
@@ -190,6 +190,7 @@
 network_port(transproxy, tcp,8081,s0)
 type utcpserver_port_t, port_type; dnl network_port(utcpserver) # no defined portcon
 network_port(uucpd, tcp,540,s0)
+network_port(ups, tcp,3493,s0)
 network_port(varnishd, tcp,6081,s0, tcp,6082,s0)
 network_port(vnc, tcp,5900,s0)
 network_port(wccp, udp,2048,s0)
diff -b -B --ignore-all-space -N -u -r nsaserefpolicy/policy/modules/services/nut.fc serefpolicy-3.6.32/policy/modules/services/nut.fc
--- nsaserefpolicy/policy/modules/services/nut.fc	1970-01-01 01:00:00.000000000 +0100
+++ serefpolicy-3.6.32/policy/modules/services/nut.fc	2010-01-29 15:53:08.974638937 +0100
@@ -0,0 +1,14 @@
+
+/etc/ups(/.*)?          gen_context(system_u:object_r:nut_conf_t,s0)
+
+/sbin/upsdrvctl     --  gen_context(system_u:object_r:nut_upsdrvctl_exec_t,s0)
+
+/usr/sbin/upsd      --  gen_context(system_u:object_r:nut_upsd_exec_t,s0)
+/usr/sbin/upsmon    --  gen_context(system_u:object_r:nut_upsmon_exec_t,s0)
+
+/var/run/nut(/.*)?                  gen_context(system_u:object_r:nut_var_run_t,s0)
+
+/var/www/nut-cgi-bin/upsimage\.cgi  --  gen_context(system_u:object_r:httpd_nutups_cgi_script_exec_t,s0)
+/var/www/nut-cgi-bin/upsset\.cgi    --  gen_context(system_u:object_r:httpd_nutups_cgi_script_exec_t,s0)
+/var/www/nut-cgi-bin/upsstats\.cgi  --  gen_context(system_u:object_r:httpd_nutups_cgi_script_exec_t,s0)
+
diff -b -B --ignore-all-space -N -u -r nsaserefpolicy/policy/modules/services/nut.if serefpolicy-3.6.32/policy/modules/services/nut.if
--- nsaserefpolicy/policy/modules/services/nut.if	1970-01-01 01:00:00.000000000 +0100
+++ serefpolicy-3.6.32/policy/modules/services/nut.if	2010-01-29 15:51:24.747389099 +0100
@@ -0,0 +1,58 @@
+## <summary>SELinux policy for NUT - Network UPS Tools </summary>
+
+#####################################
+## <summary>
+##      Execute a domain transition to run upsd.
+## </summary>
+## <param name="domain">
+## <summary>
+##      Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`nut_upsd_domtrans',`
+	gen_require(`
+		type nut_upsd_t, nut_upsd_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, nut_upsd_exec_t, nut_upsd_t)
+')
+
+####################################
+## <summary>
+##      Execute a domain transition to run upsmon.
+## </summary>
+## <param name="domain">
+## <summary>
+##      Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`nut_upsmon_domtrans',`
+	gen_require(`
+		type nut_upsmon_t, nut_upsmon_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, nut_upsmon_exec_t, nut_upsmon_t)
+')
+
+####################################
+## <summary>
+##      Execute a domain transition to run upsdrvctl.
+## </summary>
+## <param name="domain">
+## <summary>
+##      Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`nut_upsdrvctl_domtrans',`
+	gen_require(`
+		type nut_upsdrvctl_t, nut_upsdrvctl_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, nut_upsdrvctl_exec_t, nut_upsdrvctl_t)
+')
diff -b -B --ignore-all-space -N -u -r nsaserefpolicy/policy/modules/services/nut.te serefpolicy-3.6.32/policy/modules/services/nut.te
--- nsaserefpolicy/policy/modules/services/nut.te	1970-01-01 01:00:00.000000000 +0100
+++ serefpolicy-3.6.32/policy/modules/services/nut.te	2010-01-29 16:05:24.831641057 +0100
@@ -0,0 +1,177 @@
+
+policy_module(nut, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+type nut_upsd_t;
+typealias nut_upsd_t alias upsd_t;
+type nut_upsd_exec_t;
+init_daemon_domain(nut_upsd_t, nut_upsd_exec_t)
+
+type nut_upsmon_t;
+typealias nut_upsmon_t alias upsmon_t;
+type nut_upsmon_exec_t;
+init_daemon_domain(nut_upsmon_t, nut_upsmon_exec_t)
+
+type nut_upsdrvctl_t;
+typealias nut_upsdrvctl_t alias upsdrvctl_t;
+type nut_upsdrvctl_exec_t;
+init_daemon_domain(nut_upsdrvctl_t, nut_upsdrvctl_exec_t)
+
+# conf files
+type nut_conf_t;
+files_config_file(nut_conf_t)
+
+# pid files
+type nut_var_run_t;
+files_pid_file(nut_var_run_t)
+
+########################################
+#
+# Local policy for upsd
+#
+
+allow nut_upsd_t self:capability { setgid setuid dac_override };
+
+allow nut_upsd_t self:unix_dgram_socket { create_socket_perms sendto };
+allow nut_upsd_t self:tcp_socket connected_stream_socket_perms;
+
+allow nut_upsd_t nut_upsdrvctl_t:unix_stream_socket connectto;
+
+read_files_pattern(nut_upsd_t, nut_conf_t, nut_conf_t)
+
+# pid file
+manage_files_pattern(nut_upsd_t, nut_var_run_t, nut_var_run_t)
+manage_dirs_pattern(nut_upsd_t, nut_var_run_t, nut_var_run_t)
+manage_sock_files_pattern(nut_upsd_t, nut_var_run_t, nut_var_run_t)
+files_pid_filetrans(nut_upsd_t, nut_var_run_t, { file sock_file })
+
+corenet_tcp_bind_ups_port(nut_upsd_t)
+corenet_tcp_bind_all_nodes(nut_upsd_t)
+
+kernel_read_kernel_sysctls(nut_upsd_t)
+
+# /etc/nsswitch.conf
+auth_use_nsswitch(nut_upsd_t)
+
+files_read_usr_files(nut_upsd_t)
+
+logging_send_syslog_msg(nut_upsd_t)
+
+miscfiles_read_localization(nut_upsd_t)
+
+
+########################################
+#
+# Local policy for upsmon
+#
+
+allow nut_upsmon_t self:capability { dac_override dac_read_search setgid setuid };
+
+allow nut_upsmon_t self:fifo_file rw_fifo_file_perms;
+allow nut_upsmon_t self:unix_dgram_socket { create_socket_perms sendto };
+allow nut_upsmon_t self:tcp_socket create_socket_perms;
+
+read_files_pattern(nut_upsmon_t, nut_conf_t, nut_conf_t)
+
+# pid file
+manage_files_pattern(nut_upsmon_t, nut_var_run_t, nut_var_run_t)
+manage_dirs_pattern(nut_upsmon_t, nut_var_run_t, nut_var_run_t)
+files_pid_filetrans(nut_upsmon_t, nut_var_run_t, { file })
+
+corenet_tcp_connect_ups_port(nut_upsmon_t)
+
+corecmd_exec_bin(nut_upsmon_t)
+corecmd_exec_shell(nut_upsmon_t)
+
+kernel_read_kernel_sysctls(nut_upsmon_t)
+kernel_read_system_state(nut_upsmon_t)
+
+# Creates /etc/killpower
+files_manage_etc_runtime_files(nut_upsmon_t)
+files_etc_filetrans_etc_runtime(nut_upsmon_t, file)
+
+auth_use_nsswitch(nut_upsmon_t)
+
+files_search_usr(nut_upsmon_t)
+
+logging_send_syslog_msg(nut_upsmon_t)
+
+miscfiles_read_localization(nut_upsmon_t)
+
+# /usr/bin/wall
+term_write_all_terms(nut_upsmon_t)
+
+#upsmon runs shutdown, probably need a shutdown domain
+init_rw_utmp(nut_upsmon_t)
+init_telinit(nut_upsmon_t)
+
+########################################
+#
+# Local policy for upsdrvctl
+#
+
+allow nut_upsdrvctl_t self:capability { dac_override kill setgid setuid };
+allow nut_upsdrvctl_t self:process { sigchld signal signull };
+allow nut_upsdrvctl_t self:fd use;
+
+allow nut_upsdrvctl_t self:fifo_file rw_fifo_file_perms;
+allow nut_upsdrvctl_t self:unix_dgram_socket { create_socket_perms sendto };
+allow nut_upsdrvctl_t self:udp_socket create_socket_perms;
+
+read_files_pattern(nut_upsdrvctl_t, nut_conf_t, nut_conf_t)
+
+# pid file
+manage_files_pattern(nut_upsdrvctl_t, nut_var_run_t, nut_var_run_t)
+manage_dirs_pattern(nut_upsdrvctl_t, nut_var_run_t, nut_var_run_t)
+manage_sock_files_pattern(nut_upsdrvctl_t, nut_var_run_t, nut_var_run_t)
+files_pid_filetrans(nut_upsdrvctl_t, nut_var_run_t, { file sock_file })
+
+# /sbin/upsdrvctl executes other drivers
+corecmd_exec_bin(nut_upsdrvctl_t)
+corecmd_exec_sbin(nut_upsdrvctl_t)
+
+kernel_read_kernel_sysctls(nut_upsdrvctl_t)
+
+# /etc/nsswitch.conf
+auth_use_nsswitch(nut_upsdrvctl_t)
+
+dev_read_urand(nut_upsdrvctl_t)
+dev_rw_generic_usb_dev(nut_upsdrvctl_t)
+
+term_use_unallocated_ttys(nut_upsdrvctl_t)
+
+logging_send_syslog_msg(nut_upsdrvctl_t)
+
+miscfiles_read_localization(nut_upsdrvctl_t)
+
+init_sigchld(nut_upsdrvctl_t)
+
+#######################################
+#
+# Local policy for NUT cgi scripts
+# requires httpd_enable_cgi and httpd_can_network_connect
+#
+
+optional_policy(`
+    apache_content_template(nutups_cgi)
+
+    read_files_pattern(httpd_nutups_cgi_script_t, nut_conf_t, nut_conf_t)
+
+    corenet_all_recvfrom_unlabeled(httpd_nutups_cgi_script_t)
+    corenet_all_recvfrom_netlabel(httpd_nutups_cgi_script_t)
+    corenet_tcp_sendrecv_generic_if(httpd_nutups_cgi_script_t)
+    corenet_tcp_sendrecv_generic_node(httpd_nutups_cgi_script_t)
+    corenet_tcp_sendrecv_all_ports(httpd_nutups_cgi_script_t)
+    corenet_tcp_connect_ups_port(httpd_nutups_cgi_script_t)
+    corenet_udp_sendrecv_generic_if(httpd_nutups_cgi_script_t)
+    corenet_udp_sendrecv_generic_node(httpd_nutups_cgi_script_t)
+    corenet_udp_sendrecv_all_ports(httpd_nutups_cgi_script_t)
+
+    sysnet_dns_name_resolve(httpd_nutups_cgi_script_t)
+')
+
+
